Chat
Completions
Create chat completion
$ openai chat:completions create
post /chat/completions
Starting a new project? We recommend trying Responses to take advantage of the latest OpenAI platform features. Compare Chat Completions with Responses.
Creates a model response for the given chat conversation. Learn more in the text generation, vision, and audio guides.
Parameter support can differ depending on the model used to generate the response, particularly for newer reasoning models. Parameters that are only supported for reasoning models are noted below. For the current state of unsupported parameters in reasoning models, refer to the reasoning guide.
Returns a chat completion object, or a streamed sequence of chat completion chunk objects if the request is streamed.
Parameters
-
--message: array of ChatCompletionMessageParamA list of messages comprising the conversation so far. Depending on the model you use, different message types (modalities) are supported, like text, images, and audio.
-
--model: string or ChatModelModel ID used to generate the response, like
gpt-4ooro3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models. -
--audio: optional object { format, voice }Parameters for audio output. Required when audio output is requested with
modalities: ["audio"]. Learn more. -
--frequency-penalty: optional numberNumber between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.
-
--function-call: optional "none" or "auto" or ChatCompletionFunctionCallOptionDeprecated in favor of
tool_choice.Controls which (if any) function is called by the model.
nonemeans the model will not call a function and instead generates a message.automeans the model can pick between generating a message or calling a function.Specifying a particular function via
{"name": "my_function"}forces the model to call that function.noneis the default when no functions are present.autois the default if functions are present. -
--function: optional array of object { name, description, parameters }Deprecated in favor of
tools.A list of functions the model may generate JSON inputs for.
-
--logit-bias: optional map[number]Modify the likelihood of specified tokens appearing in the completion.
Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.
-
--logprobs: optional booleanWhether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the
contentofmessage. -
--max-completion-tokens: optional numberAn upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens.
-
--max-tokens: optional numberThe maximum number of tokens that can be generated in the chat completion. This value can be used to control costs for text generated via API.
This value is now deprecated in favor of
max_completion_tokens, and is not compatible with o-series models. -
--metadata: optional map[string]Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
--modality: optional array of "text" or "audio"Output types that you would like the model to generate. Most models are capable of generating text, which is the default:
["text"]The
gpt-4o-audio-previewmodel can also be used to generate audio. To request that this model generate both text and audio responses, you can use:["text", "audio"] -
--n: optional numberHow many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep
nas1to minimize costs. -
--parallel-tool-calls: optional booleanWhether to enable parallel function calling during tool use.
-
--prediction: optional object { content, type }Static predicted output content, such as the content of a text file that is being regenerated.
-
--presence-penalty: optional numberNumber between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.
-
--prompt-cache-key: optional stringUsed by OpenAI to cache responses for similar requests to optimize your cache hit rates. Replaces the
userfield. Learn more. -
--prompt-cache-retention: optional "in_memory" or "24h"The retention policy for the prompt cache. Set to
24hto enable extended prompt caching, which keeps cached prefixes active for longer, up to a maximum of 24 hours. Learn more. -
--reasoning-effort: optional "none" or "minimal" or "low" or 3 moreConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high, andxhigh. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1.- All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. - The
gpt-5-promodel defaults to (and only supports)highreasoning effort. xhighis supported for all models aftergpt-5.1-codex-max.
-
--response-format: optional ResponseFormatText or ResponseFormatJSONSchema or ResponseFormatJSONObjectAn object specifying the format that the model must output.
Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables the older JSON mode, which ensures the message the model generates is valid JSON. Usingjson_schemais preferred for models that support it. -
--safety-identifier: optional stringA stable identifier used to help detect users of your application that may be violating OpenAI's usage policies. The IDs should be a string that uniquely identifies each user, with a maximum length of 64 characters. We recommend hashing their username or email address, in order to avoid sending us any identifying information. Learn more.
-
--seed: optional numberThis feature is in Beta. If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same
seedand parameters should return the same result. Determinism is not guaranteed, and you should refer to thesystem_fingerprintresponse parameter to monitor changes in the backend. -
--service-tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter. -
--stop: optional string or array of stringNot supported with latest reasoning models
o3ando4-mini.Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.
-
--store: optional booleanWhether or not to store the output of this chat completion request for use in our model distillation or evals products.
Supports text and image inputs. Note: image inputs over 8MB will be dropped.
-
--stream-options: optional object { include_obfuscation, include_usage }Options for streaming response. Only set this when you set
stream: true. -
--temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or
top_pbut not both. -
--tool-choice: optional "none" or "auto" or "required" or ChatCompletionAllowedToolChoice or ChatCompletionNamedToolChoice or ChatCompletionNamedToolChoiceCustomControls which (if any) tool is called by the model.
nonemeans the model will not call any tool and instead generates a message.automeans the model can pick between generating a message or calling one or more tools.requiredmeans the model must call one or more tools. Specifying a particular tool via{"type": "function", "function": {"name": "my_function"}}forces the model to call that tool.noneis the default when no tools are present.autois the default if tools are present. -
--tool: optional array of ChatCompletionToolA list of tools the model may call. You can provide either custom tools or function tools.
-
--top-logprobs: optional numberAn integer between 0 and 20 specifying the maximum number of most likely tokens to return at each token position, each with an associated log probability. In some cases, the number of returned tokens may be fewer than requested.
logprobsmust be set totrueif this parameter is used. -
--top-p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or
temperaturebut not both. -
--user: optional stringThis field is being replaced by
safety_identifierandprompt_cache_key. Useprompt_cache_keyinstead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more. -
--verbosity: optional "low" or "medium" or "high"Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are
low,medium, andhigh. -
--web-search-options: optional object { search_context_size, user_location }This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
Returns
-
chat_completion: object { id, choices, created, 5 more }Represents a chat completion response returned by model, based on the provided input.
-
id: stringA unique identifier for the chat completion.
-
choices: array of object { finish_reason, index, logprobs, message }A list of chat completion choices. Can be more than one if
nis greater than 1.-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created.
-
model: stringThe model used for the chat completion.
-
object: "chat.completion"The object type, which is always
chat.completion. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }Usage statistics for the completion request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
Example
openai chat:completions create \
--api-key 'My API Key' \
--message '{content: string, role: developer}' \
--model gpt-5.4
Response
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"content": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
],
"refusal": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
]
},
"message": {
"content": "content",
"refusal": "refusal",
"role": "assistant",
"annotations": [
{
"type": "url_citation",
"url_citation": {
"end_index": 0,
"start_index": 0,
"title": "title",
"url": "https://example.com"
}
}
],
"audio": {
"id": "id",
"data": "data",
"expires_at": 0,
"transcript": "transcript"
},
"function_call": {
"arguments": "arguments",
"name": "name"
},
"tool_calls": [
{
"id": "id",
"function": {
"arguments": "arguments",
"name": "name"
},
"type": "function"
}
]
}
}
],
"created": 0,
"model": "model",
"object": "chat.completion",
"service_tier": "auto",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cached_tokens": 0
}
}
}
List Chat Completions
$ openai chat:completions list
get /chat/completions
List stored Chat Completions. Only Chat Completions that have been stored
with the store parameter set to true will be returned.
Parameters
-
--after: optional stringIdentifier for the last chat completion from the previous pagination request.
-
--limit: optional numberNumber of Chat Completions to retrieve.
-
--metadata: optional map[string]A list of metadata keys to filter the Chat Completions by. Example:
metadata[key1]=value1&metadata[key2]=value2 -
--model: optional stringThe model used to generate the Chat Completions.
-
--order: optional "asc" or "desc"Sort order for Chat Completions by timestamp. Use
ascfor ascending order ordescfor descending order. Defaults toasc.
Returns
-
ChatCompletionList: object { data, first_id, has_more, 2 more }An object representing a list of Chat Completions.
-
data: array of ChatCompletionAn array of chat completion objects.
-
id: stringA unique identifier for the chat completion.
-
choices: array of object { finish_reason, index, logprobs, message }A list of chat completion choices. Can be more than one if
nis greater than 1.-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created.
-
model: stringThe model used for the chat completion.
-
object: "chat.completion"The object type, which is always
chat.completion. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }Usage statistics for the completion request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
-
first_id: stringThe identifier of the first chat completion in the data array.
-
has_more: booleanIndicates whether there are more Chat Completions available.
-
last_id: stringThe identifier of the last chat completion in the data array.
-
object: "list"The type of this object. It is always set to "list".
-
Example
openai chat:completions list \
--api-key 'My API Key'
Response
{
"data": [
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"content": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
],
"refusal": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
]
},
"message": {
"content": "content",
"refusal": "refusal",
"role": "assistant",
"annotations": [
{
"type": "url_citation",
"url_citation": {
"end_index": 0,
"start_index": 0,
"title": "title",
"url": "https://example.com"
}
}
],
"audio": {
"id": "id",
"data": "data",
"expires_at": 0,
"transcript": "transcript"
},
"function_call": {
"arguments": "arguments",
"name": "name"
},
"tool_calls": [
{
"id": "id",
"function": {
"arguments": "arguments",
"name": "name"
},
"type": "function"
}
]
}
}
],
"created": 0,
"model": "model",
"object": "chat.completion",
"service_tier": "auto",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cached_tokens": 0
}
}
}
],
"first_id": "first_id",
"has_more": true,
"last_id": "last_id",
"object": "list"
}
Get chat completion
$ openai chat:completions retrieve
get /chat/completions/{completion_id}
Get a stored chat completion. Only Chat Completions that have been created
with the store parameter set to true will be returned.
Parameters
-
--completion-id: stringThe ID of the chat completion to retrieve.
Returns
-
chat_completion: object { id, choices, created, 5 more }Represents a chat completion response returned by model, based on the provided input.
-
id: stringA unique identifier for the chat completion.
-
choices: array of object { finish_reason, index, logprobs, message }A list of chat completion choices. Can be more than one if
nis greater than 1.-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created.
-
model: stringThe model used for the chat completion.
-
object: "chat.completion"The object type, which is always
chat.completion. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }Usage statistics for the completion request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
Example
openai chat:completions retrieve \
--api-key 'My API Key' \
--completion-id completion_id
Response
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"content": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
],
"refusal": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
]
},
"message": {
"content": "content",
"refusal": "refusal",
"role": "assistant",
"annotations": [
{
"type": "url_citation",
"url_citation": {
"end_index": 0,
"start_index": 0,
"title": "title",
"url": "https://example.com"
}
}
],
"audio": {
"id": "id",
"data": "data",
"expires_at": 0,
"transcript": "transcript"
},
"function_call": {
"arguments": "arguments",
"name": "name"
},
"tool_calls": [
{
"id": "id",
"function": {
"arguments": "arguments",
"name": "name"
},
"type": "function"
}
]
}
}
],
"created": 0,
"model": "model",
"object": "chat.completion",
"service_tier": "auto",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cached_tokens": 0
}
}
}
Update chat completion
$ openai chat:completions update
post /chat/completions/{completion_id}
Modify a stored chat completion. Only Chat Completions that have been
created with the store parameter set to true can be modified. Currently,
the only supported modification is to update the metadata field.
Parameters
-
--completion-id: stringThe ID of the chat completion to update.
-
--metadata: map[string]Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
Returns
-
chat_completion: object { id, choices, created, 5 more }Represents a chat completion response returned by model, based on the provided input.
-
id: stringA unique identifier for the chat completion.
-
choices: array of object { finish_reason, index, logprobs, message }A list of chat completion choices. Can be more than one if
nis greater than 1.-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created.
-
model: stringThe model used for the chat completion.
-
object: "chat.completion"The object type, which is always
chat.completion. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }Usage statistics for the completion request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
Example
openai chat:completions update \
--api-key 'My API Key' \
--completion-id completion_id \
--metadata '{foo: string}'
Response
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"content": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
],
"refusal": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0,
"top_logprobs": [
{
"token": "token",
"bytes": [
0
],
"logprob": 0
}
]
}
]
},
"message": {
"content": "content",
"refusal": "refusal",
"role": "assistant",
"annotations": [
{
"type": "url_citation",
"url_citation": {
"end_index": 0,
"start_index": 0,
"title": "title",
"url": "https://example.com"
}
}
],
"audio": {
"id": "id",
"data": "data",
"expires_at": 0,
"transcript": "transcript"
},
"function_call": {
"arguments": "arguments",
"name": "name"
},
"tool_calls": [
{
"id": "id",
"function": {
"arguments": "arguments",
"name": "name"
},
"type": "function"
}
]
}
}
],
"created": 0,
"model": "model",
"object": "chat.completion",
"service_tier": "auto",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cached_tokens": 0
}
}
}
Delete chat completion
$ openai chat:completions delete
delete /chat/completions/{completion_id}
Delete a stored chat completion. Only Chat Completions that have been
created with the store parameter set to true can be deleted.
Parameters
-
--completion-id: stringThe ID of the chat completion to delete.
Returns
-
chat_completion_deleted: object { id, deleted, object }-
id: stringThe ID of the chat completion that was deleted.
-
deleted: booleanWhether the chat completion was deleted.
-
object: "chat.completion.deleted"The type of object being deleted.
-
Example
openai chat:completions delete \
--api-key 'My API Key' \
--completion-id completion_id
Response
{
"id": "id",
"deleted": true,
"object": "chat.completion.deleted"
}
Domain Types
Chat Completion
-
chat_completion: object { id, choices, created, 5 more }Represents a chat completion response returned by model, based on the provided input.
-
id: stringA unique identifier for the chat completion.
-
choices: array of object { finish_reason, index, logprobs, message }A list of chat completion choices. Can be more than one if
nis greater than 1.-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created.
-
model: stringThe model used for the chat completion.
-
object: "chat.completion"The object type, which is always
chat.completion. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }Usage statistics for the completion request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
Chat Completion Allowed Tool Choice
-
chat_completion_allowed_tool_choice: object { allowed_tools, type }Constrains the tools available to the model to a pre-defined set.
-
allowed_tools: object { mode, tools }Constrains the tools available to the model to a pre-defined set.
-
mode: "auto" or "required"Constrains the tools available to the model to a pre-defined set.
autoallows the model to pick from among the allowed tools and generate a message.requiredrequires the model to call one or more of the allowed tools.-
"auto" -
"required"
-
-
tools: array of map[unknown]A list of tool definitions that the model should be allowed to call.
For the Chat Completions API, the list of tool definitions might look like:
[ { "type": "function", "function": { "name": "get_weather" } }, { "type": "function", "function": { "name": "get_time" } } ]
-
-
type: "allowed_tools"Allowed tool configuration type. Always
allowed_tools.
-
Chat Completion Assistant Message Param
-
chat_completion_assistant_message_param: object { role, audio, content, 4 more }Messages sent by the model in response to user messages.
-
role: "assistant"The role of the messages author, in this case
assistant. -
audio: optional object { id }Data about a previous audio response from the model. Learn more.
-
id: stringUnique identifier for a previous audio response from the model.
-
-
content: optional string or array of ChatCompletionContentPartText or ChatCompletionContentPartRefusalThe contents of the assistant message. Required unless
tool_callsorfunction_callis specified.-
Text content: stringThe contents of the assistant message.
-
Array of content parts: array of ChatCompletionContentPartText or ChatCompletionContentPartRefusalAn array of content parts with a defined type. Can be one or more of type
text, or exactly one of typerefusal.-
chat_completion_content_part_text: object { text, type }Learn about text inputs.
-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
chat_completion_content_part_refusal: object { refusal, type }-
refusal: stringThe refusal message generated by the model.
-
type: "refusal"The type of the content part.
-
-
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
refusal: optional stringThe refusal message by the assistant.
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
Chat Completion Audio
-
chat_completion_audio: object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
Chat Completion Audio Param
-
chat_completion_audio_param: object { format, voice }Parameters for audio output. Required when audio output is requested with
modalities: ["audio"]. Learn more.-
format: "wav" or "aac" or "mp3" or 3 moreSpecifies the output audio format. Must be one of
wav,mp3,flac,opus, orpcm16.-
"wav" -
"aac" -
"mp3" -
"flac" -
"opus" -
"pcm16"
-
-
voice: string or "alloy" or "ash" or "ballad" or 7 more or object { id }The voice the model uses to respond. Supported built-in voices are
alloy,ash,ballad,coral,echo,fable,nova,onyx,sage,shimmer,marin, andcedar. You may also provide a custom voice object with anid, for example{ "id": "voice_1234" }.-
union_member_0: string -
union_member_1: "alloy" or "ash" or "ballad" or 7 more-
"alloy" -
"ash" -
"ballad" -
"coral" -
"echo" -
"sage" -
"shimmer" -
"verse" -
"marin" -
"cedar"
-
-
id: object { id }Custom voice reference.
-
id: stringThe custom voice ID, e.g.
voice_1234.
-
-
-
Chat Completion Chunk
-
chat_completion_chunk: object { id, choices, created, 5 more }Represents a streamed chunk of a chat completion response returned by the model, based on the provided input. Learn more.
-
id: stringA unique identifier for the chat completion. Each chunk has the same ID.
-
choices: array of object { delta, finish_reason, index, logprobs }A list of chat completion choices. Can contain more than one elements if
nis greater than 1. Can also be empty for the last chunk if you setstream_options: {"include_usage": true}.-
delta: object { content, function_call, refusal, 2 more }A chat completion delta generated by streamed model responses.
-
content: optional stringThe contents of the chunk message.
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: optional stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: optional stringThe name of the function to call.
-
-
refusal: optional stringThe refusal message generated by the model.
-
role: optional "developer" or "system" or "user" or 2 moreThe role of the author of this message.
-
"developer" -
"system" -
"user" -
"assistant" -
"tool"
-
-
tool_calls: optional array of object { index, id, function, type }-
index: number -
id: optional stringThe ID of the tool call.
-
function: optional object { arguments, name }-
arguments: optional stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: optional stringThe name of the function to call.
-
-
type: optional "function"The type of the tool. Currently, only
functionis supported."function"
-
-
-
finish_reason: "stop" or "length" or "tool_calls" or 2 moreThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached,content_filterif content was omitted due to a flag from our content filters,tool_callsif the model called a tool, orfunction_call(deprecated) if the model called a function.-
"stop" -
"length" -
"tool_calls" -
"content_filter" -
"function_call"
-
-
index: numberThe index of the choice in the list of choices.
-
logprobs: optional object { content, refusal }Log probability information for the choice.
-
content: array of ChatCompletionTokenLogprobA list of message content tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely.
-
-
-
refusal: array of ChatCompletionTokenLogprobA list of message refusal tokens with log probability information.
-
token: stringThe token.
-
bytes: array of numberA list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be
nullif there is no bytes representation for the token. -
logprob: numberThe log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value
-9999.0is used to signify that the token is very unlikely. -
top_logprobs: array of object { token, bytes, logprob }List of the most likely tokens and their log probability, at this token position. The number of entries may be fewer than the requested
top_logprobs.
-
-
-
-
created: numberThe Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.
-
model: stringThe model to generate the completion.
-
object: "chat.completion.chunk"The object type, which is always
chat.completion.chunk. -
service_tier: optional "auto" or "default" or "flex" or 2 moreSpecifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the
service_tierparameter is set, the response body will include theservice_tiervalue based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.-
"auto" -
"default" -
"flex" -
"scale" -
"priority"
-
system_fingerprint: optional stringThis fingerprint represents the backend configuration that the model runs with. Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
usage: optional object { completion_tokens, prompt_tokens, total_tokens, 2 more }An optional field that will only be present when you set
stream_options: {"include_usage": true}in your request. When present, it contains a null value except for the last chunk which contains the token usage statistics for the entire request.NOTE: If the stream is interrupted or cancelled, you may not receive the final usage chunk which contains the total token usage for the request.
-
completion_tokens: numberNumber of tokens in the generated completion.
-
prompt_tokens: numberNumber of tokens in the prompt.
-
total_tokens: numberTotal number of tokens used in the request (prompt + completion).
-
completion_tokens_details: optional object { accepted_prediction_tokens, audio_tokens, reasoning_tokens, rejected_prediction_tokens }Breakdown of tokens used in a completion.
-
accepted_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
audio_tokens: optional numberAudio input tokens generated by the model.
-
reasoning_tokens: optional numberTokens generated by the model for reasoning.
-
rejected_prediction_tokens: optional numberWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
prompt_tokens_details: optional object { audio_tokens, cached_tokens }Breakdown of tokens used in the prompt.
-
audio_tokens: optional numberAudio input tokens present in the prompt.
-
cached_tokens: optional numberCached tokens present in the prompt.
-
-
-
Chat Completion Content Part
-
chat_completion_content_part: ChatCompletionContentPartText or ChatCompletionContentPartImage or ChatCompletionContentPartInputAudio or object { file, type }Learn about text inputs.
-
chat_completion_content_part_text: object { text, type }Learn about text inputs.
-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
chat_completion_content_part_image: object { image_url, type }Learn about image inputs.
-
image_url: object { url, detail }-
url: stringEither a URL of the image or the base64 encoded image data.
-
detail: optional "auto" or "low" or "high"Specifies the detail level of the image. Learn more in the Vision guide.
-
"auto" -
"low" -
"high"
-
-
-
type: "image_url"The type of the content part.
-
-
chat_completion_content_part_input_audio: object { input_audio, type }Learn about audio inputs.
-
input_audio: object { data, format }-
data: stringBase64 encoded audio data.
-
format: "wav" or "mp3"The format of the encoded audio data. Currently supports "wav" and "mp3".
-
"wav" -
"mp3"
-
-
-
type: "input_audio"The type of the content part. Always
input_audio.
-
-
file: object { file, type }Learn about file inputs for text generation.
-
file: object { file_data, file_id, filename }-
file_data: optional stringThe base64 encoded file data, used when passing the file to the model as a string.
-
file_id: optional stringThe ID of an uploaded file to use as input.
-
filename: optional stringThe name of the file, used when passing the file to the model as a string.
-
-
type: "file"The type of the content part. Always
file.
-
-
Chat Completion Content Part Image
-
chat_completion_content_part_image: object { image_url, type }Learn about image inputs.
-
image_url: object { url, detail }-
url: stringEither a URL of the image or the base64 encoded image data.
-
detail: optional "auto" or "low" or "high"Specifies the detail level of the image. Learn more in the Vision guide.
-
"auto" -
"low" -
"high"
-
-
-
type: "image_url"The type of the content part.
-
Chat Completion Content Part Input Audio
-
chat_completion_content_part_input_audio: object { input_audio, type }Learn about audio inputs.
-
input_audio: object { data, format }-
data: stringBase64 encoded audio data.
-
format: "wav" or "mp3"The format of the encoded audio data. Currently supports "wav" and "mp3".
-
"wav" -
"mp3"
-
-
-
type: "input_audio"The type of the content part. Always
input_audio.
-
Chat Completion Content Part Refusal
-
chat_completion_content_part_refusal: object { refusal, type }-
refusal: stringThe refusal message generated by the model.
-
type: "refusal"The type of the content part.
-
Chat Completion Content Part Text
-
chat_completion_content_part_text: object { text, type }Learn about text inputs.
-
text: stringThe text content.
-
type: "text"The type of the content part.
-
Chat Completion Custom Tool
-
chat_completion_custom_tool: object { custom, type }A custom tool that processes input using a specified format.
-
custom: object { name, description, format }Properties of the custom tool.
-
name: stringThe name of the custom tool, used to identify it in tool calls.
-
description: optional stringOptional description of the custom tool, used to provide more context.
-
format: optional object { type } or object { grammar, type }The input format for the custom tool. Default is unconstrained text.
-
text: object { type }Unconstrained free-form text.
-
grammar: object { grammar, type }A grammar defined by the user.
-
grammar: object { definition, syntax }Your chosen grammar.
-
definition: stringThe grammar definition.
-
syntax: "lark" or "regex"The syntax of the grammar definition. One of
larkorregex.-
"lark" -
"regex"
-
-
-
type: "grammar"Grammar format. Always
grammar.
-
-
-
-
type: "custom"The type of the custom tool. Always
custom.
-
Chat Completion Deleted
-
chat_completion_deleted: object { id, deleted, object }-
id: stringThe ID of the chat completion that was deleted.
-
deleted: booleanWhether the chat completion was deleted.
-
object: "chat.completion.deleted"The type of object being deleted.
-
Chat Completion Developer Message Param
-
chat_completion_developer_message_param: object { content, role, name }Developer-provided instructions that the model should follow, regardless of messages sent by the user. With o1 models and newer,
developermessages replace the previoussystemmessages.-
content: string or array of ChatCompletionContentPartTextThe contents of the developer message.
-
Text content: stringThe contents of the developer message.
-
Array of content parts: array of ChatCompletionContentPartTextAn array of content parts with a defined type. For developer messages, only type
textis supported.-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
-
role: "developer"The role of the messages author, in this case
developer. -
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
Chat Completion Function Call Option
-
chat_completion_function_call_option: object { name }Specifying a particular function via
{"name": "my_function"}forces the model to call that function.-
name: stringThe name of the function to call.
-
Chat Completion Function Message Param
-
chat_completion_function_message_param: object { content, name, role }-
content: stringThe contents of the function message.
-
name: stringThe name of the function to call.
-
role: "function"The role of the messages author, in this case
function.
-
Chat Completion Function Tool
-
chat_completion_function_tool: object { function, type }A function tool that can be used to generate a response.
-
function: object { name, description, parameters, strict }-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional map[unknown]The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
Chat Completion Message
-
chat_completion_message: object { content, refusal, role, 4 more }A chat completion message generated by the model.
-
content: stringThe contents of the message.
-
refusal: stringThe refusal message generated by the model.
-
role: "assistant"The role of the author of this message.
-
annotations: optional array of object { type, url_citation }Annotations for the message, when applicable, as when using the web search tool.
-
type: "url_citation"The type of the URL citation. Always
url_citation. -
url_citation: object { end_index, start_index, title, url }A URL citation when using web search.
-
end_index: numberThe index of the last character of the URL citation in the message.
-
start_index: numberThe index of the first character of the URL citation in the message.
-
title: stringThe title of the web resource.
-
url: stringThe URL of the web resource.
-
-
-
audio: optional object { id, data, expires_at, transcript }If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
-
id: stringUnique identifier for this audio response.
-
data: stringBase64 encoded audio bytes generated by the model, in the format specified in the request.
-
expires_at: numberThe Unix timestamp (in seconds) for when this audio response will no longer be accessible on the server for use in multi-turn conversations.
-
transcript: stringTranscript of the audio generated by the model.
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
Chat Completion Message Custom Tool Call
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
Chat Completion Message Function Tool Call
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
Chat Completion Message Param
-
chat_completion_message_param: ChatCompletionDeveloperMessageParam or ChatCompletionSystemMessageParam or ChatCompletionUserMessageParam or 3 moreDeveloper-provided instructions that the model should follow, regardless of messages sent by the user. With o1 models and newer,
developermessages replace the previoussystemmessages.-
chat_completion_developer_message_param: object { content, role, name }Developer-provided instructions that the model should follow, regardless of messages sent by the user. With o1 models and newer,
developermessages replace the previoussystemmessages.-
content: string or array of ChatCompletionContentPartTextThe contents of the developer message.
-
Text content: stringThe contents of the developer message.
-
Array of content parts: array of ChatCompletionContentPartTextAn array of content parts with a defined type. For developer messages, only type
textis supported.-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
-
role: "developer"The role of the messages author, in this case
developer. -
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
-
chat_completion_system_message_param: object { content, role, name }Developer-provided instructions that the model should follow, regardless of messages sent by the user. With o1 models and newer, use
developermessages for this purpose instead.-
content: string or array of ChatCompletionContentPartTextThe contents of the system message.
-
Text content: stringThe contents of the system message.
-
Array of content parts: array of ChatCompletionContentPartTextAn array of content parts with a defined type. For system messages, only type
textis supported.-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
-
role: "system"The role of the messages author, in this case
system. -
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
-
chat_completion_user_message_param: object { content, role, name }Messages sent by an end user, containing prompts or additional context information.
-
content: string or array of ChatCompletionContentPartThe contents of the user message.
-
Text content: stringThe text contents of the message.
-
Array of content parts: array of ChatCompletionContentPartAn array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text, image, or audio inputs.
-
chat_completion_content_part_text: object { text, type }Learn about text inputs.
-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
chat_completion_content_part_image: object { image_url, type }Learn about image inputs.
-
image_url: object { url, detail }-
url: stringEither a URL of the image or the base64 encoded image data.
-
detail: optional "auto" or "low" or "high"Specifies the detail level of the image. Learn more in the Vision guide.
-
"auto" -
"low" -
"high"
-
-
-
type: "image_url"The type of the content part.
-
-
chat_completion_content_part_input_audio: object { input_audio, type }Learn about audio inputs.
-
input_audio: object { data, format }-
data: stringBase64 encoded audio data.
-
format: "wav" or "mp3"The format of the encoded audio data. Currently supports "wav" and "mp3".
-
"wav" -
"mp3"
-
-
-
type: "input_audio"The type of the content part. Always
input_audio.
-
-
file: object { file, type }Learn about file inputs for text generation.
-
file: object { file_data, file_id, filename }-
file_data: optional stringThe base64 encoded file data, used when passing the file to the model as a string.
-
file_id: optional stringThe ID of an uploaded file to use as input.
-
filename: optional stringThe name of the file, used when passing the file to the model as a string.
-
-
type: "file"The type of the content part. Always
file.
-
-
-
-
role: "user"The role of the messages author, in this case
user. -
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
-
chat_completion_assistant_message_param: object { role, audio, content, 4 more }Messages sent by the model in response to user messages.
-
role: "assistant"The role of the messages author, in this case
assistant. -
audio: optional object { id }Data about a previous audio response from the model. Learn more.
-
id: stringUnique identifier for a previous audio response from the model.
-
-
content: optional string or array of ChatCompletionContentPartText or ChatCompletionContentPartRefusalThe contents of the assistant message. Required unless
tool_callsorfunction_callis specified.-
Text content: stringThe contents of the assistant message.
-
Array of content parts: array of ChatCompletionContentPartText or ChatCompletionContentPartRefusalAn array of content parts with a defined type. Can be one or more of type
text, or exactly one of typerefusal.-
chat_completion_content_part_text: object { text, type }Learn about text inputs.
-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
chat_completion_content_part_refusal: object { refusal, type }-
refusal: stringThe refusal message generated by the model.
-
type: "refusal"The type of the content part.
-
-
-
-
function_call: optional object { arguments, name }Deprecated and replaced by
tool_calls. The name and arguments of a function that should be called, as generated by the model.-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
name: optional stringAn optional name for the participant. Provides the model information to differentiate between participants of the same role.
-
refusal: optional stringThe refusal message by the assistant.
-
tool_calls: optional array of ChatCompletionMessageToolCallThe tool calls generated by the model, such as function calls.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
-
-
chat_completion_tool_message_param: object { content, role, tool_call_id }-
content: string or array of ChatCompletionContentPartTextThe contents of the tool message.
-
Text content: stringThe contents of the tool message.
-
Array of content parts: array of ChatCompletionContentPartTextAn array of content parts with a defined type. For tool messages, only type
textis supported.-
text: stringThe text content.
-
type: "text"The type of the content part.
-
-
-
role: "tool"The role of the messages author, in this case
tool. -
tool_call_id: stringTool call that this message is responding to.
-
-
chat_completion_function_message_param: object { content, name, role }-
content: stringThe contents of the function message.
-
name: stringThe name of the function to call.
-
role: "function"The role of the messages author, in this case
function.
-
-
Chat Completion Message Tool Call
-
chat_completion_message_tool_call: ChatCompletionMessageFunctionToolCall or ChatCompletionMessageCustomToolCallA call to a function tool created by the model.
-
chat_completion_message_function_tool_call: object { id, function, type }A call to a function tool created by the model.
-
id: stringThe ID of the tool call.
-
function: object { arguments, name }The function that the model called.
-
arguments: stringThe arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function.
-
name: stringThe name of the function to call.
-
-
type: "function"The type of the tool. Currently, only
functionis supported.
-
-
chat_completion_message_custom_tool_call: object { id, custom, type }A call to a custom tool created by the model.
-
id: stringThe ID of the tool call.
-
custom: object { input, name }The custom tool that the model called.
-
input: stringThe input for the custom tool call generated by the model.
-
name: stringThe name of the custom tool to call.
-
-
type: "custom"The type of the tool. Always
custom.
-
-
Chat Completion Modality
-
chat_completion_modality: "text" or "audio"-
"text" -
"audio"
-
Chat Completion Named Tool Choice
-
chat_completion_named_tool_choice: object { function, type }Specifies a tool the model should use. Use to force the model to call a specific function.
-
function: object { name }-
name: stringThe name of the function to call.
-
-
[...]
